diff --git a/clients/drcachesim/tests/window_test.cpp b/clients/drcachesim/tests/window_test.cpp
index b20e6675f9b..d309eb4f982 100644
--- a/clients/drcachesim/tests/window_test.cpp
+++ b/clients/drcachesim/tests/window_test.cpp
@@ -120,7 +120,7 @@ gather_trace()
 {
     std::string dr_ops(
         "-stderr_mask 0xc -client_lib ';;-offline -offline -trace_after_instrs 1000 "
-        "-trace_for_instrs 2500 -retrace_every_instrs 100");
+        "-trace_for_instrs 2500 -retrace_every_instrs 1000");
     if (!my_setenv("DYNAMORIO_OPTIONS", dr_ops.c_str()))
         std::cerr << "failed to set env var!\n";
     dr_app_setup();
diff --git a/clients/drcachesim/tracer/output.cpp b/clients/drcachesim/tracer/output.cpp
index 9be39696027..05108db5a6d 100644
--- a/clients/drcachesim/tracer/output.cpp
+++ b/clients/drcachesim/tracer/output.cpp
@@ -1340,11 +1340,13 @@ exit_thread_io(void *drcontext)
             BUF_PTR(data->seg_base), dr_get_thread_id(drcontext));
 
         ptr_int_t window = get_local_window(data);
-        process_and_output_buffer(drcontext,
-                                  /* If this thread already wrote some data, include
-                                   * its exit even if we're over a size limit.
-                                   */
-                                  data->bytes_written > 0);
+        if (is_in_tracing_mode(tracing_mode.load(std::memory_order_acquire)) &&
+            get_local_window(data) == window)
+            process_and_output_buffer(drcontext,
+                                      /* If this thread already wrote some data, include
+                                       * its exit even if we're over a size limit.
+                                       */
+                                      data->bytes_written > 0);
         if (get_local_window(data) != window) {
             BUF_PTR(data->seg_base) += instru->append_thread_exit(
                 BUF_PTR(data->seg_base), dr_get_thread_id(drcontext));
